' Monochrome Port of Adafruit graphics library with drivers for i2c ssd1306 display
'
' assumes a graphics display where top left is point 0,0
'
'sub setRotation(x) 'sets screen rotation: 0=normal, 1=invert, 2=rotate right, 3-rotate left
'sub drawCircle(x0,y0,r) 'x,y coordinates of centre, radius
'sub fillCircle(x0, y0, r)  'x,y coordinates of centre, radius
'sub drawTriangle(x0, y0, x1,  y1,	x2, y2) 'three coordinate pairs
'sub fillTriangle (x0, y0, x1,  y1,	x2, y2) 'three coordinate pairs
'sub drawChar(xx, yy, ch, size, orientation) 'x,y coordinates of top left of first character, ascii character, size, orientation
'sub printstring(xx0,yy0,text$,size,orientation) 'x,y coordinates of top left of first character, text string, size, orientation
'sub drawLine(xx0,yy0,xx1,yy1)' x,y of start line, x,y of end line
'sub drawRect(x,y,w,h) 'x,y coordinate of top left, width, height
'sub fillrect(x, y, w, h)'x,y coordinate of top left, width, height
'sub drawRoundRect(x, y, w, h, r) 'x,y coordinates of top left, width, height, radius of corner
'sub fillRoundRect(x, y, w, h, r) 'x,y coordinates of top left, width, height, radius of corner
'
' These routines just update the memory image of the display
' Use the refresh command to write to the display as required
'
'CFunctions
'unsigned long long fastfillrect(unsigned int *sense,unsigned int *x,unsigned int *y, unsigned int *width,unsigned int *height, unsigned int *rotation, unsigned int *screenwidth, unsigned int *screenheight,unsigned long long screen[]){
'unsigned long long NOKIA5110_getnextupdate(unsigned int *outchar,unsigned int *col, unsigned int *row,unsigned int *maxcols,unsigned int *maxrows, unsigned long long screen[], unsigned long long displayed[]){
'unsigned long long SSD1306_getnextupdate(unsigned char outchar[],unsigned int *startcol, unsigned int *startrow,unsigned int *col, unsigned int *row, unsigned int *maxcols,unsigned int *maxrows, unsigned long long screen[], unsigned long long displayed[]){
'unsigned long long drawPixel(unsigned int *onoff, unsigned int *x, unsigned int *y, unsigned int *rotation, unsigned int *width, unsigned int *height, unsigned long long p_array[]){
'long long charload(long long loadarray[])
'
cpu 48
OPTION EXPLICIT
OPTION DEFAULT INTEGER
'option autorun on
const normal=0
const inverse=1
const rotate_right=2
const rotate_left=3
const ON=1
const OFF=0
const SSD1306=0 'display code for SSD1306 i2c display
const NOKIA5110=1 ' display code for NOKIA5110 SPI display
const DisplayInUse=SSD1306 'set the display to be used
const charheight=8 
const charwidth=6
'
' SSD1306 Display specific constants
const SSD1306_width=128
const SSD1306_height=64
const SSD1306_NUM_ROWS = SSD1306_height/8 'memory is arranged as rows 8 bits high
const SSD1306_i2caddr=&H3C
const SSD1306_SETCONTRAST =&H81
const SSD1306_DISPLAYALLON_RESUME =&HA4
const SSD1306_DISPLAYALLON =&HA5
const SSD1306_NORMALDISPLAY =&HA6
const SSD1306_INVERTDISPLAY =&HA7
const SSD1306_DISPLAYOFF =&HAE
const SSD1306_DISPLAYON =&HAF
const SSD1306_SETDISPLAYOFFSET =&HD3
const SSD1306_SETCOMPINS =&HDA
const SSD1306_SETVCOMDETECT =&HDB
const SSD1306_SETDISPLAYCLOCKDIV =&HD5
const SSD1306_SETPRECHARGE =&HD9
const SSD1306_SETMULTIPLEX =&HA8
const SSD1306_SETLOWCOLUMN =&H00
const SSD1306_SETHIGHCOLUMN =&H10
const SSD1306_SETSTARTLINE =&H40
const SSD1306_MEMORYMODE =&H20
const SSD1306_COLUMNADDR =&H21
const SSD1306_PAGEADDR   =&H22
const SSD1306_COMSCANINC =&HC0
const SSD1306_COMSCANDEC =&HC8
const SSD1306_SEGREMAP =&HA0
const SSD1306_CHARGEPUMP =&H8D
const SSD1306_EXTERNALVCC =&H1
const SSD1306_SWITCHCAPVCC =&H2'
'
' Nokia 5110 Display specific constants
'
const NOKIA5110_WIDTH=84
const NOKIA5110_HEIGHT=48
const NOKIA5110_NUM_ROWS      = NOKIA5110_Height/8
const NOKIA5110_EXTENDED_COMMAND = &H21
const NOKIA5110_BASIC_COMMAND  = &H20
const NOKIA5110_TEMP_COEFFICIENT = &H05
const NOKIA5110_BIAS  = &H14
const NOKIA5110_BLANK = &H08
const NOKIA5110_ALL_ON = &H09
const NOKIA5110_D_NORMAL = &H0C
const NOKIA5110_D_INVERSE = &H0D
const NOKIA5110_xcursor=&H80
const NOKIA5110_ycursor=&H40
const NOKIA5110_CONTRAST = &HB0 'adjust for individual display
'
' pin assignments for Nokia 5110
'
const NOKIA5110_RST=24
const NOKIA5110_CE=23
const NOKIA5110_DC=15
const NOKIA5110_Datain=3
const NOKIA5110_CLK=25
const NOKIA5110_VCC=7
'
'
dim width,height,num_rows,i2caddr,rot_height,rot_width,size,numchars
dim c(255)
dim screen(128),displayed(128) 'set up arrays for screen map to mimic display
dim i,j,k,char
dim rotation
 '
init: 
  print "Starting initialisation" 
  if DisplayInUse=SSD1306 then   
     print "Using ssd1306" 
     width=SSD1306_width 
     height=SSD1306_height 
     num_rows=SSD1306_num_rows 
     i2caddr=SSD1306_i2caddr 
     initSSD1306display 'initialise the display 
  endif 
  if DisplayInUse=NOKIA5110 then 
     print "Using NOKIA5110" 
     width=NOKIA5110_width 
     height=NOKIA5110_height 
     num_rows=NOKIA5110_num_rows 
     initNOKIA5110display 'initialise the display 
  endif 
  i=charload(c()) 
  setrotation(normal) 
  print "starting main" 
 ' 
Main: 
' test drawing rectangles
  if DisplayInUse=ssd1306 then ssd1306_clearscreen 
  if DisplayInUse=NOKIA5110 then NOKIA5110_clearscreen 
  for i=0 to 3
     setrotation(i) 
     fillrect(5,5,10,15)
     drawrect(2,2,16,21)
     if DisplayInUse=ssd1306 then ssd1306_refresh
     if DisplayInUse=NOKIA5110 then NOKIA5110_refresh
  next i
  pause 2000
' test drawing rounded rectangles
  if DisplayInUse=ssd1306 then ssd1306_clearscreen 
  if DisplayInUse=NOKIA5110 then NOKIA5110_clearscreen 
  for i=0 to 3
     setrotation(i) 
     fillroundrect(5,5,10,15,4)
     drawroundrect(2,2,16,21,6)
     if DisplayInUse=ssd1306 then ssd1306_refresh
     if DisplayInUse=NOKIA5110 then NOKIA5110_refresh
  next i
  pause 2000
' test drawing circles
  if DisplayInUse=ssd1306 then ssd1306_clearscreen 
  if DisplayInUse=NOKIA5110 then NOKIA5110_clearscreen 
  for i=0 to 3
     setrotation(i) 
     fillcircle(10,10,7)
     drawcircle(10,10,9)
     if DisplayInUse=ssd1306 then ssd1306_refresh
     if DisplayInUse=NOKIA5110 then NOKIA5110_refresh
  next i
  pause 2000
' test drawing triangles and line drawing
  if DisplayInUse=ssd1306 then ssd1306_clearscreen 
  if DisplayInUse=NOKIA5110 then NOKIA5110_clearscreen 
  for i=0 to 3
     setrotation(i) 
     filltriangle(4,4,20,6,12,14)
     drawtriangle(1,2,24,4,12,17)
     if DisplayInUse=ssd1306 then ssd1306_refresh
     if DisplayInUse=NOKIA5110 then NOKIA5110_refresh
  next i
  pause 2000
' test character output and string output at all orientations
  for size=1 to 3
  numchars=2 'number of characters in the string I'm using
  if DisplayInUse=ssd1306 then ssd1306_clearscreen 
  if DisplayInUse=NOKIA5110 then NOKIA5110_clearscreen 
  for i=0 to 3
     setrotation(i) 
     printstring(0,0,"0"+chr$(48+i),size,normal)
     if DisplayInUse=ssd1306 then ssd1306_refresh
     if DisplayInUse=NOKIA5110 then NOKIA5110_refresh
  next i
  pause 2000
  if DisplayInUse=ssd1306 then ssd1306_clearscreen 
  if DisplayInUse=NOKIA5110 then NOKIA5110_clearscreen 
  for i=0 to 3
     setrotation(i) 
     printstring(charwidth*size*numchars-1,charheight*size-1,"1"+chr$(48+i),size,inverse)
     if DisplayInUse=ssd1306 then ssd1306_refresh
     if DisplayInUse=NOKIA5110 then NOKIA5110_refresh
  next i
  pause 2000
  if DisplayInUse=ssd1306 then ssd1306_clearscreen 
  if DisplayInUse=NOKIA5110 then NOKIA5110_clearscreen 
  for i=0 to 3
     setrotation(i) 
     printstring(charheight*size-1,0,"2"+chr$(48+i),size,rotate_right)
     if DisplayInUse=ssd1306 then ssd1306_refresh
     if DisplayInUse=NOKIA5110 then NOKIA5110_refresh
  next i
  pause 2000
  if DisplayInUse=ssd1306 then ssd1306_clearscreen 
  if DisplayInUse=NOKIA5110 then NOKIA5110_clearscreen 
  for i=0 to 3
     setrotation(i) 
     printstring(0,charwidth*size*numchars-1,"3"+chr$(48+i),size,rotate_left)
     if DisplayInUse=ssd1306 then ssd1306_refresh
     if DisplayInUse=NOKIA5110 then NOKIA5110_refresh
  next i
  pause 2000
  next size
' 
  goto main 
end 
'
'
'*******************************************************************************************
'
' SSD1306 Display specific routines
'
sub initSSD1306display 'i2c oled
  I2C OPEN 400,1000
    ssd1306_command(SSD1306_DISPLAYOFF)' &HAE
    ssd1306_command(SSD1306_SETDISPLAYCLOCKDIV)'&HD5
    ssd1306_command(&H80)'the suggested ratio &H80
    ssd1306_command(SSD1306_SETMULTIPLEX)'&HA8
    ssd1306_command(&H3F)'
    ssd1306_command(SSD1306_SETDISPLAYOFFSET)'&HD3
    ssd1306_command(&H0)'no offset
    ssd1306_command(SSD1306_SETSTARTLINE )'line #0
    ssd1306_command(SSD1306_CHARGEPUMP)'&H8D
    ssd1306_command(&H14)
    ssd1306_command(SSD1306_MEMORYMODE)' &H20
    ssd1306_command(&H00)'&H0 act like ks0108
    ssd1306_command(SSD1306_SEGREMAP OR 1);
    ssd1306_command(SSD1306_COMSCANDEC);
    ssd1306_command(SSD1306_SETCOMPINS)' &HDA
    ssd1306_command(&H12)
    ssd1306_command(SSD1306_SETCONTRAST)'&H81
    ssd1306_command(&HCF)
    ssd1306_command(SSD1306_SETPRECHARGE)'&Hd9
    ssd1306_command(&HF1)
    ssd1306_command(SSD1306_SETVCOMDETECT)'&HDB
    ssd1306_command(&H40)
    ssd1306_command(SSD1306_DISPLAYALLON_RESUME)'&HA4
    ssd1306_command(SSD1306_NORMALDISPLAY)'&HA6
    ssd1306_command(SSD1306_DISPLAYON)
'  
    ssd1306_clearscreen
end sub
'
Sub ssd1306_Command(command)
  I2C WRITE i2caddr,0,2,&H00,command
end sub
 '
 '
sub ssd1306_SendData(Dchar)
  I2C WRITE i2caddr,0,2,&H40,Dchar
end sub
'
sub SSD1306_refresh
    ssd1306_cursor(0,0)
    local rows=0
    local cols=0
    local startrow
    local startcol
    local outchar$=""
    local retstatus
    do 
      retstatus=ssd1306getnextupdate(outchar$,startcol,startrow,cols,rows,width,num_rows,screen(),displayed())
      if retstatus<>0 then
          ssd1306_cursor(startcol, startrow)
          i2c write i2caddr,0,len(outchar$),outchar$
      endif
    loop while retstatus<>0
end sub
'
Sub SSD1306_ClearScreen
  local i,j
  for i=0 to 7
    ssd1306_cursor(0,i)
    for j=0 to 127 step 16
      I2C WRITE i2caddr,0,33,&H40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
    next j
  next i
  for i=0 to 127
    screen(i)=0
    displayed(i)=0
  next i
end sub
 '
sub SSD1306_Cursor(x,y)
  ssd1306_command(&HB0 + y)                //set page address
  ssd1306_command(&H10+(x>>4 and &H0F))  //set high col address
  ssd1306_command(&H00+(x AND &H0f))       //set low col address
end sub
'
'*******************************************************************************************
'
' Nokia5110 Display specific routines
'
sub initNOKIA5110display 
  setpin NOKIA5110_RST, dout
  SETPIN NOKIA5110_CE, DOUT
  SETPIN NOKIA5110_DC, DOUT
  SETPIN NOKIA5110_VCC, DOUT
  spi open 6000000,3,8
  PIN(NOKIA5110_VCC)=0 'turn off display power
  pause 500
  pin(NOKIA5110_RST)=1 'set RESET high
  PIN(NOKIA5110_VCC)=1 'Turn on the power
  PIN(NOKIA5110_RST)=0
  PIN(NOKIA5110_RST)=1 'reset the display
  NOKIA5110_SendCommand(NOKIA5110_EXTENDED_COMMAND)
  NOKIA5110_SendCommand(NOKIA5110_TEMP_COEFFICIENT)
  NOKIA5110_SendCommand(NOKIA5110_BIAS)
  NOKIA5110_SendCommand(NOKIA5110_BASIC_COMMAND)
  NOKIA5110_SendCommand(NOKIA5110_D_NORMAL)
  NOKIA5110_ClearScreen
  NOKIA5110_SendCommand(NOKIA5110_EXTENDED_COMMAND)
  NOKIA5110_SendCommand(NOKIA5110_CONTRAST OR &H80)
  NOKIA5110_SendCommand(NOKIA5110_BASIC_COMMAND)
end sub
'
sub NOKIA5110_refresh
    local rows=0
    local cols=0
    local outchar
    local retstatus
    NOKIA5110_cursor(0,0)
    do 
      retstatus=nokia5110getnextupdate(outchar,cols,rows,width,num_rows,screen(),displayed())
      if retstatus=0 then NOKIA5110_senddata(outchar)
      if retstatus=1 then
         NOKIA5110_cursor(cols,rows)
         NOKIA5110_senddata(outchar)
      endif
    loop while retstatus<>2
end sub
'
Sub NOKIA5110_SendCommand(command)
  pin(NOKIA5110_DC)=0                   ' Send this byte as a command
  PIN(NOKIA5110_CE)=0
  local i=spi(command)
  PIN(NOKIA5110_CE)=1
end sub
'
sub NOKIA5110_SendData(Dchar)
  PIN(NOKIA5110_DC)=1                   ' Send this byte as data
  PIN(NOKIA5110_CE)=0
  local i=spi(Dchar)
  PIN(NOKIA5110_CE)=1
end sub
'
Sub NOKIA5110_ClearScreen
  local i,j
  for i=0 to num_rows-1
    for j=0 to width-1
      NOKIA5110_SendData(0)
      screen(j)=0
      displayed(j)=0
    next j
  next i
end sub
'
sub NOKIA5110_Cursor(x,y)
  NOKIA5110_SendCommand(x or NOKIA5110_xcursor)
  NOKIA5110_SendCommand(y OR NOKIA5110_ycursor)
end sub
'
'*******************************************************************************************
'
' Generic drawing routines
'
sub drawCircle(x0,y0,r) 'x,y coordinates of centre, radius
  local f=1-r
  local ddF_x=1
  local ddF_y=-2 * r
  local x=0
  local y=r
  LOCAL dp
  dp=drawpixel(ON,x0  , y0+r,rotation,width,height,screen())
  dp=drawpixel(ON,x0  , y0-r,rotation,width,height,screen())
  dp=drawpixel(ON,x0+r, y0  ,rotation,width,height,screen())
  dp=drawpixel(ON,x0-r, y0  ,rotation,width,height,screen())
  do while (x<y)
    if f >= 0 then
      y=y-1
      ddF_y = ddF_y+2
      f = f+ddF_y
    endif
    x=x+1
    ddF_x = ddF_x+2
    f = f+  ddF_x

    dp=drawpixel(ON,x0 + x, y0 + y,rotation,width,height,screen())
    dp=drawpixel(ON,x0 - x, y0 + y,rotation,width,height,screen())
    dp=drawpixel(ON,x0 + x, y0 - y,rotation,width,height,screen())
    dp=drawpixel(ON,x0 - x, y0 - y,rotation,width,height,screen())
    dp=drawpixel(ON,x0 + y, y0 + x,rotation,width,height,screen())
    dp=drawpixel(ON,x0 - y, y0 + x,rotation,width,height,screen())
    dp=drawpixel(ON,x0 + y, y0 - x,rotation,width,height,screen())
    dp=drawpixel(ON,x0 - y, y0 - x,rotation,width,height,screen())
  loop
end sub
 '
sub drawTriangle(x0, y0, x1,  y1,	x2, y2) 'three coordinate pairs
  drawLine(x0, y0, x1, y1)
  drawLine(x1, y1, x2, y2)
  drawLine(x2, y2, x0, y0)
end sub
 '
sub fillTriangle (x0, y0, x1,  y1,	x2, y2) 'three coordinate pairs
  local a, b, y, dp, last
  if (y0 > y1) then
    swap(y0, y1)
    swap(x0, x1)
  endif
  if (y1 > y2) then
    swap(y2, y1)
    swap(x2, x1)
  endif
  if (y0 > y1) then
    swap(y0, y1)
    swap(x0, x1)
  endif
  if(y0 = y2) then ' Handle awkward all-on-same-line case as its own thing
    a = x0
    b = x0
    if(x1 < a) then
      a = x1
    else
      if(x1 > b) then b = x1
    endif
    if(x2 < a) then
      a = x2
    else
      if(x2 > b) then b = x2
    endif
    drawFastHLine(a, y0, b-a+1)
    exit sub
  endif
    local  dx01=x1 - x0
    local  dy01=y1 - y0
    local  dx02=x2 - x0
    local  dy02=y2 - y0
    local  dx12=x2 - x1
    local  dy12=y2 - y1
    local sa   = 0
    local sb   = 0
  if(y1 = y2) then
    last = y1 'Include y1 scanline
  else
     last = y1-1 ' Skip it
  endif
  for y=y0 to last
    a   = x0 + sa / dy01
    b   = x0 + sb / dy02
    sa = sa + dx01
    sb = sb + dx02
    a = x0 + (x1 - x0) * (y - y0) / (y1 - y0)
    b = x0 + (x2 - x0) * (y - y0) / (y2 - y0)
    if(a > b) then swap(a,b)
'    drawFastHLine(a, y, b-a+1)
    dp=fastfillrect(ON,a, y, b-a+1,1,rotation,width,height,screen()) 
  next y
  sa = dx12 * (y - y1)
  sb = dx02 * (y - y0)
  do while y<=y2
    a   = x1 + sa / dy12
    b   = x0 + sb / dy02
    sa = sa+dx12
    sb = sb+dx02
    a = x1 + (x2 - x1) * (y - y1) / (y2 - y1)
    b = x0 + (x2 - x0) * (y - y0) / (y2 - y0)
    if(a > b) then swap(a,b)
    dp=fastfillrect(ON,a, y, b-a+1,1,rotation,width,height,screen()) 
    y=y+1
  loop
end sub
 '
sub printstring(xx0,yy0,text$,size,orientation) 'x,y coordinates of top left of first character, text string, size, orientation
  local i,c
  local x = xx0
  local y = yy0
  for i=1 to len(text$)
    c=asc(mid$(text$,i,1))
    drawchar(x,y,c,size,orientation)
    on orientation+1 goto pnormal,pinvert,protateright,protateleft
pnormal:
    x=x+(6*size)
    goto pcontinue
pinvert:
    x=x-(6*size)
    goto pcontinue
protateright:
    y=y+(6*size)
    goto pcontinue
protateleft:
    y=y-(6*size)
pcontinue:
  next i
end sub
 '
sub drawLine(xx0,yy0,xx1,yy1) ' x,y of start line, x,y of end line
  local dx, dy
  local x0=xx0
  local y0=yy0
  local x1=xx1
  local y1=yy1
  local err,ystep,dp
  local steep = (abs(y1 - y0)) > (abs(x1 - x0))
  if (steep) then
    swap(x0, y0)
    swap(x1, y1)
  endif
  if (x0 > x1) then
    swap(x0, x1)
    swap(y0, y1)
  endif
  dx = x1 - x0
  dy = abs(y1 - y0)
  err = dx / 2
  if y0 < y1 then
    ystep = 1
  else
    ystep = -1
  endif
  do while x0<=x1
    if (steep) then
      dp=drawpixel(ON,y0, x0,rotation,width,height,screen())
    else
      dp=drawpixel(ON,x0, y0,rotation,width,height,screen())
    endif
    err = err- dy
    if err < 0) then
      y0 = y0+ ystep
      err = err+ dx
    endif
    x0=x0+1
  loop
end sub
 '
sub swap a,b
  local t
  t=b
  b=a
  a=t
end sub
 '
sub drawRect(x,y,w,h) 'x,y coordinate of top left, width, height
  local a,dp
  dp=fastfillrect(ON,x, y, w,1,rotation,width,height,screen()) 
  a=y+h-1
  dp=fastfillrect(ON,x, a, w,1,rotation,width,height,screen()) 
  dp=fastfillrect(ON,x, y, 1,h,rotation,width,height,screen()) 
  a=x+w-1
  dp=fastfillrect(ON,a, y, 1,h,rotation,width,height,screen()) 
end sub
'
sub fillrect(x,y,w,h) 'x,y coordinate of top left, width, height
  local dp
  dp=fastfillrect(ON,x, y, w,h,rotation,width,height,screen()) 
end sub
'
sub drawChar(xx, yy, ch, size, orientation) 'x,y coordinates of top left of first character, ascii character, size, orientation
  local i,j,x,y,dp,addr,character
  x=xx
  y=yy
  character=c(ch) 'loads the character
  on orientation+1 goto dnormal,dinvert,drotateright,drotateleft
dnormal:
  for i=0 to 5 
    for j = 0 to 7
      if (character >> (i*8+j)) and 1 then
        if (size = 1) then
          dp=drawpixel(ON,x+5-i, y+j,rotation,width,height,screen())
        else
          dp=fastfillrect(ON,x+(5-i)*size, y+(j*size), size, size,rotation,width,height,screen())
        endif
       else
        if (size = 1) then
          dp=drawpixel(OFF,x+5-i, y+j,rotation,width,height,screen())
        else
          dp=fastfillrect(OFF,x+(5-i)*size, y+(j*size), size, size,rotation,width,height,screen())
        endif
       endif
     next j
  next i
  exit sub
 '
dinvert:
  for i=0 to 5 'step down the lines
    for j = 0 to 7
      if (character >> (8*(5-i)+7-j)) and 1 then
        if (size = 1) then
          dp=drawpixel(ON,x-i, y+j-7,rotation,width,height,screen())
        else
          dp=fastfillrect(ON,x-size+1-(i*size), y-size+1+((j-7)*size), size, size,rotation,width,height,screen())
        endif
       else
        if (size = 1) then
          dp=drawpixel(OFF,x-i, y+j-7,rotation,width,height,screen())
        else
          dp=fastfillrect(OFF,x-size+1-(i*size), y-size+1+((j-7)*size), size, size,rotation,width,height,screen())
        endif
       endif
     next j
  next i
  exit sub
 '
drotateright:
  for i=0 to 7 'step across the rows
    for j = 0 to 5
      if (character >> ((5-j)*8 + i)) and 1 then
        if (size = 1) then
          dp=drawpixel(ON,x-i, y+j,rotation,width,height,screen())
        else
          dp=fastfillrect(ON,x-size+1-i*size, y+(j)*size, size, size,rotation,width,height,screen())
        endif
       else
        if (size = 1) then
          dp=drawpixel(OFF,x-i, y+j,rotation,width,height,screen())
        else
          dp=fastfillrect(OFF,x-size+1-i*size, y+(j)*size, size, size,rotation,width,height,screen())
        endif
       endif
     next j
  next i
  exit sub
drotateleft:
  for i=0 to 7 'step across the rows
    for j = 0 to 5
'      if bits(5-j,i) then
      if (character >> (8*j+7-i)) and 1 then
        if (size = 1) then
          dp=drawpixel(ON,x-i+7, y+j-5,rotation,width,height,screen())
        else
          dp=fastfillrect(ON,x-i*size+7*size+1, y+j*size-6*size+1, size, size,rotation,width,height,screen())
        endif
       else
        if (size = 1) then
          dp=drawpixel(OFF,x-i+7, y+j-5,rotation,width,height,screen())
        else
          dp=fastfillrect(OFF,x-i*size+7*size+1, y+j*size-6*size+1, size, size,rotation,width,height,screen())
        endif
       endif
     next j
  next i
end sub
'

sub fillCircle(x0, y0, r)  'x,y coordinates of centre, radius
  local dp
  dp=fastfillrect(ON,x0, y0-r, 1, 2*r+1,rotation,width,height,screen())
  fillCircleHelper(x0, y0, r, 3, 0);
end sub
 '
sub drawRoundRect(x, y, w,  h, r) 'x,y coordinates of top left, width, height, radius of corner
  local dp
  dp=fastfillrect(ON,x+r  , y    , w-2*r,1,rotation,width,height,screen()) 
  dp=fastfillrect(ON,x+r  , y+h-1, w-2*r,1,rotation,width,height,screen()) 
  dp=fastfillrect(ON,x    , y+r  , 1,h-2*r,rotation,width,height,screen()) 
  dp=fastfillrect(ON,x+w-1, y+r  , 1,h-2*r,rotation,width,height,screen()) 
  drawCircleHelper(x+r    , y+r    , r, 1)
  drawCircleHelper(x+w-r-1, y+r    , r, 2)
  drawCircleHelper(x+w-r-1, y+h-r-1, r, 4)
  drawCircleHelper(x+r    , y+h-r-1, r, 8)
end sub
 '
sub drawCircleHelper( x0, y0,r,cornername)
  local f     = 1 - r
  local ddF_x = 1
  local ddF_y = -2 * r
  local x     = 0
  local y     = r
  local dp

  do while (x<y)
    if (f >= 0) then
      y=y-1
      ddF_y = ddF_y+ 2
      f     = f+ddF_y
    endif
    x=x+1
    ddF_x =ddF_x+ 2
    f     = f+ddF_x
    if (cornername and 4) then
      dp=drawpixel(ON,x0 + x, y0 + y,rotation,width,height,screen())
      dp=drawpixel(ON,x0 + y, y0 + x,rotation,width,height,screen())
    endif
    if (cornername and 2) then
      dp=drawpixel(ON,x0 + x, y0 - y,rotation,width,height,screen())
      dp=drawpixel(ON,x0 + y, y0 - x,rotation,width,height,screen())
    endif
    if (cornername and 8) then
      dp=drawpixel(ON,x0 - y, y0 + x,rotation,width,height,screen())
      dp=drawpixel(ON,x0 - x, y0 + y,rotation,width,height,screen())
    endif
    if (cornername and 1) then
      dp=drawpixel(ON,x0 - y, y0 - x,rotation,width,height,screen())
      dp=drawpixel(ON,x0 - x, y0 - y,rotation,width,height,screen())
    endif
  loop
end sub
 '
sub fillCircleHelper(x0, y0, r,cornername, delta)
  local dp
  local f     = 1 - r
  local ddF_x = 1
  local ddF_y = -2 * r
  local x     = 0
  local y     = r

  do while x<y
    if f >= 0 then
      y=y-1
      ddF_y =ddF_y+ 2
      f     = f+ddF_y
    endif
    x=x+1
    ddF_x = ddF_x+2
    f     = f+ddF_x

    if (cornername and 1) then
      dp=fastfillrect(ON,x0+x, y0-y,1, 2*y+1+delta,rotation,width,height,screen()) 
      dp=fastfillrect(ON,x0+y, y0-x,1, 2*x+1+delta,rotation,width,height,screen()) 
    endif
    if (cornername and 2) then
      dp=fastfillrect(ON,x0-x, y0-y,1, 2*y+1+delta,rotation,width,height,screen()) 
      dp=fastfillrect(ON,x0-y, y0-x,1, 2*x+1+delta,rotation,width,height,screen()) 
    endif
  loop
end sub
 '
sub fillRoundRect(x, y, w,h, r) 'x,y coordinates of top left, width, height, radius of corner
  local dp
  dp=fastfillrect(ON,x+r, y, w-2*r, h,rotation,width,height,screen()) 
  fillCircleHelper(x+w-r-1, y+r, r, 1, h-2*r-1)
  fillCircleHelper(x+r    , y+r, r, 2, h-2*r-1)
end sub
 '
sub setRotation(x) 'sets screen rotation: 0=normal, 1=invert, 2=rotate right, 3-rotate left
  rotation = (x and 3)
  rot_width=width
  rot_height=height
  if x>=2 then
    rot_width=height
    rot_height=width
  endif
end sub
'
'*******************************************************************************************
'
' CFunctions
'
'
'C:\Users\Peter\Dropbox\Electronics\Micromite\drawPixel.bas

'
'drawPixel  2014-11-18 19:50:39 CFuncGen Ver 1.0.16 by user=Peter
'
CFunction drawPixel
	00000000
	8faa0010 8fab0014 8ce70000 14e00006 8fac0018 8ca80000 00001821 8cc20000 
	10000019 00004821 240d0001 14ed000c 240d0002 8ca80000 00084027 8d420000 
	01024021 00001821 8cc20000 00021027 8d650000 00451021 10000015 00004821 
	14ed000a 240d0003 8ca20000 00004821 8cc80000 00084027 8d430000 01034021 
	1000000b 00001821 240d0003 54ed0009 8d460000 8ca20000 00021027 8d630000 
	00431021 00004821 8cc80000 00001821 8d460000 14600004 24050001 0106302b 
	14c00003 30a500ff 00002821 30a500ff 10a00039 00082d82 8d660000 15200004 
	24050001 0046302b 14c00003 30a500ff 00002821 30a500ff 50a0002f 00082d82 
	8c840000 10800015 00002021 15200008 00002821 15200004 24060001 2c460020 
	10c00004 24060001 10000003 00462004 24060001 00462804 000830c0 01866021 
	8d860000 00c43025 ad860000 8d860004 00c52025 10000017 ad840004 1520000a 
	24060001 15200005 00463004 2c440020 10800005 24060001 00463004 00062027 
	10000004 2405ffff 00463004 00062827 2404ffff 000830c0 01866021 8d860000 
	00c43024 ad860000 8d860004 00c52024 ad840004 00082d82 00032280 00a42025 
	00084280 01021021 0048402b 00894821 03e00008 01091821 
End CFunction

'
'fastfillrect  2014-11-18 19:50:39 CFuncGen Ver 1.0.16 by user=Peter
'
CFunction fastfillrect
	00000000
27bdffc8 afb50034 
	afb40030 afb3002c afb20028 afb10024 afb00020 8fb10048 8fa30050 8fb00054 
	8fb90058 2402ffff a3a20008 2408fffe a3a80009 2408fffc a3a8000a 2408fff8 
	a3a8000b 2408fff0 a3a8000c 2408ffe0 a3a8000d 2408ffc0 a3a8000e 2408ff80 
	a3a8000f 24080001 a3a80010 24080003 a3a80011 24080007 a3a80012 2408000f 
	a3a80013 2408001f a3a80014 2408003f a3a80015 2408007f a3a80016 a3a20017 
	8fa2004c 8c420000 1440001a 24080001 8cac0000 8c6e0000 018e782b 00004021 
	11e000fe 00004821 2598ffff 8ce80000 03084021 010ec02b 25ceffff 01d8400a 
	0100c021 8cce0000 8e120000 01d2782b 11e000f2 00004021 25cfffff 8e280000 
	01e87821 01f2402b 2652ffff 1000003d 0248c00a 1448001d 24080002 8ca50000 
	00052827 8c620000 00a21021 0040c021 00004021 044000e1 00004821 8ce70000 
	8cc50000 00052827 8e030000 00a31821 046000da 00607821 24050001 00a73823 
	00e21021 284c0000 000c100b 00406021 8e220000 00a22823 00a31821 286e0000 
	000e180b 1000003b 00607021 1448001e 24080003 8c680000 8cc90000 00094827 
	01284821 0128c02b 2508ffff 0118480a 0120c021 8e280000 01284023 25080001 
	290c0000 000c400b 01006021 8cb20000 02407021 8e130000 0253782b 00004021 
	11e000b6 00004821 2652ffff 8ce80000 02489021 0253782b 2673ffff 026f900a 
	02407821 24080003 1448001b 25c20007 8cc20000 00406021 8c630000 0043302b 
	00004021 10c000a5 00004821 2442ffff 8e260000 00461021 0043c02b 2463ffff 
	0078100a 0040c021 8ca30000 00031827 8e020000 00621021 04400098 00407821 
	8cee0000 004e1023 244e0001 29c20000 0002700b 25c20007 29c90000 01c9100a 
	000248c3 25e20007 29f00000 01f0100a 000280c3 000990c0 01d29023 001040c0 
	15300028 01e84023 01803021 030c102b 14400024 03009821 000c28c0 03252821 
	03a8a821 03b2a021 03a93821 8ca20000 8ca30004 afa20000 afa30004 8c820000 
	10400008 00a08821 92820008 92ad0010 01a26824 90e20000 01a21025 10000009 
	a0e20000 92ad0010 92820008 01a26824 000d6827 31ad00ff 90e20000 01a21024 
	a0e20000 8fa20000 8fa30004 ae220000 ae230004 24c60001 0266102b 1040ffe3 
	24a50008 25330001 0213102b 14400030 0270102b 01803021 030c102b 1440002b 
	03008821 000c28c0 03252821 03b29021 03a94821 03a8a021 03b03821 8ca20000 
	8ca30004 afa20000 afa30004 8c820000 1040000a 00a04021 924b0008 91220000 
	01621025 a1220000 928a0010 90e20000 01421025 1000000d a0e20000 924b0008 
	000b5827 316b00ff 91220000 01621024 a1220000 928a0010 000a5027 314a00ff 
	90e20000 01421024 a0e20000 8fa20000 8fa30004 ad020000 ad030004 24c60001 
	0226102b 1040ffdd 24a50008 0270102b 10400020 00001021 03b34021 03b08021 
	03004821 030c882b 000c90c0 03329021 2419ffff 16200014 01803021 02402821 
	8ca20000 8ca30004 afa20000 afa30004 8c820000 10400003 00a03821 10000002 
	a1190000 a1000000 8fa20000 8fa30004 ace20000 ace30004 24c60001 0126102b 
	1040ffef 24a50008 25080001 1510ffe9 00001021 7d823804 7f027a04 7dc2bc04 
	7de2fe04 00001821 7d633804 7d437a04 7da3bc04 00404021 00604821 01001021 
	01201821 8fb50034 8fb40030 8fb3002c 8fb20028 8fb10024 8fb00020 03e00008 
	27bd0038 
End CFunction

'
'NOKIA5110_getnextupdate  2014-11-18 19:50:39 CFuncGen Ver 1.0.16 by user=Peter
'
CFunction NOKIA5110getnextupdate
	00000000
27bdffd8 afb50024 afb40020 afb3001c afb20018 afb10014 afb00010 
	8fb90038 8faf003c 8fb80040 8ccd0000 8f220000 01a2102b 24080002 10400053 
	00004821 01a08821 03ad8021 27a20008 004d7021 8cac0000 8cf30000 0193102b 
	10400040 000c90c0 01f21021 8c430004 8c420000 afa20000 afa30004 03129021 
	8e420000 8e430004 afa20008 afa3000c 0200a021 920b0000 91c20000 104b0028 
	01c0a821 10000010 03b18821 8d420008 8d43000c afa20000 afa30004 01209021 
	8d220000 8d230004 afa20008 afa3000c 928b0000 25290008 92a20000 104b001e 
	254a0008 03b18821 a22b0008 8fa20008 8fa3000c ae420000 ae430004 ac8b0000 
	8cc20000 544d000a acac0000 8ca30000 24630001 546c0006 acac0000 aca30000 
	acc20000 00004021 10000018 00004821 accd0000 24080001 10000014 00004821 
	01804021 25890001 000948c0 03094821 000c50c0 01ea5021 25080001 1513ffd3 
	01006021 aca00000 26310001 02206821 26100001 8f220000 0222102b 1440ffb5 
	25ce0001 24080002 00004821 01001021 01201821 8fb50024 8fb40020 8fb3001c 
	8fb20018 8fb10014 8fb00010 03e00008 27bd0028 
End CFunction

'
'SSD1306_getnextupdate  2014-11-18 19:50:39 CFuncGen Ver 1.0.16 by user=Peter
'
CFunction SSD1306getnextupdate
	00000000
27bdffd0 afb6002c afb50028 
	afb40024 afb30020 afb2001c afb10018 afb00014 8fae0040 8fab0044 8fb20048 
	8fb1004c 8fad0050 24020040 a0820001 8dcf0000 8e420000 01e2102b 00004021 
	10400078 00004821 01e0c021 03af8021 27a20008 004fc821 8cec0000 8d620000 
	0182102b 50400067 27180001 01805021 000c98c0 02331021 8c430004 8c420000 
	afa20000 afa30004 01b39821 8e620000 8e630004 afa20008 afa3000c 0200a821 
	92030000 93220000 1062004c 0320b021 1000000f acac0000 8e820008 8e83000c 
	afa20000 afa30004 8e620008 8e63000c afa20008 afa3000c 26940008 92a30000 
	92c20000 10620040 26730008 acac0000 accf0000 adcf0000 acec0000 03b81021 
	90450000 90420008 10450028 24060001 8d620000 0142102b 10400024 01407821 
	000a60c0 022c8821 01ac6021 03b8c021 a3050008 000f78c0 01af7821 8fa20008 
	8fa3000c ade20000 ade30004 24c60001 00861021 a0450000 254a0001 8e220008 
	8e23000c afa20000 afa30004 8d820008 8d83000c afa20008 afa3000c 8ce20000 
	24420001 ace20000 93050000 93020008 10450006 01407821 26310008 8d620000 
	0142102b 1440ffe2 258c0008 8ce30000 8d620000 54620006 a0860000 8dc20000 
	24420001 adc20000 ace00000 a0860000 00c04021 10000013 00064fc3 000c60c0 
	022ca021 01ac9821 ace00000 254a0001 8d620000 0142102b 1440ffaf 01406021 
	27180001 03007821 26100001 8e420000 0302102b 1440ff90 27390001 00004021 
	00004821 01001021 01201821 8fb6002c 8fb50028 8fb40024 8fb30020 8fb2001c 
	8fb10018 8fb00014 03e00008 27bd0030 
End CFunction

'
'charload  2014-11-18 19:50:39 CFuncGen Ver 1.0.16 by user=Peter
'
CFunction charload
	00000000
00001021 00001821 ac820000 ac830004 
	3c024f5b 34423e00 24033e5b ac820008 ac83000c 3c024f6b 34423e00 24033e6b 
	ac820010 ac830014 3c027c3e 34421c00 24031c3e ac820018 ac83001c 3c027e3c 
	34421800 2403183c ac820020 ac830024 3c027d57 34421c00 24031c57 ac820028 
	ac83002c 3c027f5e 34421c00 24031c5e ac820030 ac830034 3c023c18 24030018 
	ac820038 ac83003c 3c02c3e7 3442ff00 3403ffe7 ac820040 ac830044 3c022418 
	24030018 ac820048 ac83004c 3c02dbe7 3442ff00 3403ffe7 ac820050 ac830054 
	3c023a06 34420e00 24033048 ac820058 ac83005c 3c027929 34422600 24032629 
	ac820060 ac830064 3c020505 34420700 2403407f ac820068 ac83006c 3c020525 
	34423f00 2403407f ac820070 ac830074 3c02e73c 34425a00 24035a3c ac820078 
	ac83007c 3c021c1c 34420800 24037f3e ac820080 ac830084 3c021c3e 34427f00 
	2403081c ac820088 ac83008c 3c027f22 34421400 24031422 ac820090 ac830094 
	3c02005f 34425f00 24035f5f ac820098 ac83009c 3c027f01 34427f00 24030609 
	ac8200a0 ac8300a4 3c028995 34426a00 24030066 ac8200a8 ac8300ac 3c026060 
	34426000 24036060 ac8200b0 ac8300b4 3c02ffa2 34429400 340394a2 ac8200b8 
	ac8300bc 3c027e04 34420800 24030804 ac8200c0 ac8300c4 3c027e20 34421000 
	24031020 ac8200c8 ac8300cc 3c022a1c 34420800 24030808 ac8200d0 ac8300d4 
	3c022a08 34420800 2403081c ac8200d8 ac8300dc 3c021010 34421000 24031e10 
	ac8200e0 ac8300e4 3c020c1e 34420c00 24030c1e ac8200e8 ac8300ec 3c023e38 
	34423000 24033038 ac8200f0 ac8300f4 3c023e0e 34420600 2403060e ac8200f8 
	ac8300fc 00001021 00001821 ac820100 ac830104 3c025f00 00001821 ac820108 
	ac83010c 3c020007 24030007 ac820110 ac830114 3c02147f 34421400 2403147f 
	ac820118 ac83011c 3c027f2a 34421200 2403242a ac820120 ac830124 3c020864 
	34426200 24032313 ac820128 ac83012c 3c025620 34425000 24033649 ac820130 
	ac830134 3c020703 24030008 ac820138 ac83013c 3c022241 2403001c ac820140 
	ac830144 3c02221c 24030041 ac820148 ac83014c 3c027f1c 34422a00 24032a1c 
	ac820150 ac830154 3c023e08 34420800 24030808 ac820158 ac83015c 3c027030 
	24030080 ac820160 ac830164 3c020808 34420800 24030808 ac820168 ac83016c 
	3c026060 00001821 ac820170 ac830174 3c020804 34420200 24032010 ac820178 
	ac83017c 3c024945 34423e00 24033e51 ac820180 ac830184 3c027f40 24030042 
	ac820188 ac83018c 3c024949 34424600 24037249 ac820190 ac830194 3c02494d 
	34423300 24032141 ac820198 ac83019c 3c02127f 34421000 24031814 ac8201a0 
	ac8301a4 3c024545 34423900 24032745 ac8201a8 ac8301ac 3c024949 34423100 
	24033c4a ac8201b0 ac8301b4 3c021109 34420700 24034121 ac8201b8 ac8301bc 
	3c024949 34423600 24033649 ac8201c0 ac8301c4 3c024929 34421e00 24034649 
	ac8201c8 ac8301cc 3c021400 00001821 ac8201d0 ac8301d4 3c023400 24030040 
	ac8201d8 ac8301dc 3c021422 34424100 24030008 ac8201e0 ac8301e4 3c081414 
	35081400 24091414 ac8801e8 ac8901ec 3c022214 34420800 24030041 ac8201f0 
	ac8301f4 3c025909 34420600 24030201 ac8201f8 ac8301fc 3c025d59 34424e00 
	24033e41 ac820200 ac830204 3c021112 34427c00 24037c12 ac820208 ac83020c 
	3c024949 34423600 24037f49 ac820210 ac830214 3c024141 34422200 24033e41 
	ac820218 ac83021c 3c024141 34423e00 24037f41 ac820220 ac830224 3c024949 
	34424100 24037f49 ac820228 ac83022c 3c020909 34420100 24037f09 ac820230 
	ac830234 3c024151 34427300 24033e41 ac820238 ac83023c 3c020808 34427f00 
	24037f08 ac820240 ac830244 3c027f41 24030041 ac820248 ac83024c 3c02413f 
	34420100 24032040 ac820250 ac830254 3c021422 34424100 24037f08 ac820258 
	ac83025c 3c024040 34424000 24037f40 ac820260 ac830264 3c021c02 34427f00 
	24037f02 ac820268 ac83026c 3c020810 34427f00 24037f04 ac820270 ac830274 
	3c024141 34423e00 24033e41 ac820278 ac83027c 3c020909 34420600 24037f09 
	ac820280 ac830284 3c025121 34425e00 24033e41 ac820288 ac83028c 3c021929 
	34424600 24037f09 ac820290 ac830294 3c024949 34423200 24032649 ac820298 
	ac83029c 3c027f01 34420300 24030301 ac8202a0 ac8302a4 3c024040 34423f00 
	24033f40 ac8202a8 ac8302ac 3c024020 34421f00 24031f20 ac8202b0 ac8302b4 
	3c023840 34423f00 24033f40 ac8202b8 ac8302bc 3c020814 34426300 24036314 
	ac8202c0 ac8302c4 3c027804 34420300 24030304 ac8202c8 ac8302cc 3c02494d 
	34424300 24036159 ac8202d0 ac8302d4 3c024141 34424100 2403007f ac8202d8 
	ac8302dc 3c020810 34422000 24030204 ac8202e0 ac8302e4 3c024141 34427f00 
	24030041 ac8202e8 ac8302ec 3c020102 34420400 24030402 ac8202f0 ac8302f4 
	3c024040 34424000 24034040 ac8202f8 ac8302fc 3c020708 24030003 ac820300 
	ac830304 3c025478 34424000 24032054 ac820308 ac83030c 3c024444 34423800 
	24037f28 ac820310 ac830314 3c024444 34422800 24033844 ac820318 ac83031c 
	3c024428 34427f00 24033844 ac820320 ac830324 3c025454 34421800 24033854 
	ac820328 ac83032c 3c027e09 34420200 24030008 ac820330 ac830334 3c02a49c 
	34427800 240318a4 ac820338 ac83033c 3c020404 34427800 24037f08 ac820340 
	ac830344 3c027d40 24030044 ac820348 ac83034c 3c02403d 24032040 ac820350 
	ac830354 3c022844 24037f10 ac820358 ac83035c 3c027f40 24030041 ac820360 
	ac830364 3c027804 34427800 24037c04 ac820368 ac83036c 3c020404 34427800 
	24037c08 ac820370 ac830374 3c024444 34423800 24033844 ac820378 ac83037c 
	3c022424 34421800 3403fc18 ac820380 ac830384 3c022418 3442fc00 24031824 
	ac820388 ac83038c 3c020404 34420800 24037c08 ac820390 ac830394 3c025454 
	34422400 24034854 ac820398 ac83039c 3c023f44 34422400 24030404 ac8203a0 
	ac8303a4 3c024020 34427c00 24033c40 ac8203a8 ac8303ac 3c024020 34421c00 
	24031c20 ac8203b0 ac8303b4 3c023040 34423c00 24033c40 ac8203b8 ac8303bc 
	3c021028 34424400 24034428 ac8203c0 ac8303c4 3c029090 34427c00 24034c90 
	ac8203c8 ac8303cc 3c02544c 34424400 24034464 ac8203d0 ac8303d4 3c023641 
	24030008 ac8203d8 ac8303dc 3c027700 00001821 ac8203e0 ac8303e4 3c023608 
	24030041 ac8203e8 ac8303ec 3c020204 34420200 24030201 ac8203f0 ac8303f4 
	3c022326 34423c00 24033c26 ac8203f8 ac8303fc 3c02a161 34421200 24031ea1 
	ac820400 ac830404 3c024020 34427a00 24033a40 ac820408 ac83040c 3c025455 
	34425900 24033854 ac820410 ac830414 3c025579 34424100 24032155 ac820418 
	ac83041c 3c025478 34424200 24032254 ac820420 ac830424 3c025478 34424000 
	24032155 ac820428 ac83042c 3c025579 34424000 24032054 ac820430 ac830434 
	3c025272 34421200 24030c1e ac820438 ac83043c 3c025555 34425900 24033955 
	ac820440 ac830444 3c025454 34425900 24033954 ac820448 ac83044c 3c025454 
	34425800 24033955 ac820450 ac830454 3c02457c 34424100 00001821 ac820458 
	ac83045c 3c02457d 34424200 24030002 ac820460 ac830464 3c02457c 34424000 
	24030001 ac820468 ac83046c 3c021112 34427d00 24037d12 ac820470 ac830474 
	3c022528 3442f000 3403f028 ac820478 ac83047c 3c025545 24037c54 ac820480 
	ac830484 3c02547c 34425400 24032054 ac820488 ac83048c 3c02097f 34424900 
	24037c0a ac820490 ac830494 3c024949 34423200 24033249 ac820498 ac83049c 
	3c024444 34423a00 24033a44 ac8204a0 ac8304a4 3c024848 34423000 2403324a 
	ac8204a8 ac8304ac 3c024121 34427a00 24033a41 ac8204b0 ac8304b4 3c024020 
	34427800 24033a42 ac8204b8 ac8304bc 3c02a0a0 34427d00 2403009d ac8204c0 
	ac8304c4 3c024242 34423d00 24033d42 ac8204c8 ac8304cc 3c024040 34423d00 
	24033d40 ac8204d0 ac8304d4 3c02ff24 34422400 24033c24 ac8204d8 ac8304dc 
	3c024943 34426600 2403487e ac8204e0 ac8304e4 3c02fc2f 34422b00 24032b2f 
	ac8204e8 ac8304ec 3c0229f6 34422000 3403ff09 ac8204f0 ac8304f4 3c027e09 
	34420300 3403c088 ac8204f8 ac8304fc 3c025479 34424100 24032054 ac820500 
	ac830504 3c02447d 34424100 00001821 ac820508 ac83050c 3c02484a 34423200 
	24033048 ac820510 ac830514 3c024022 34427a00 24033840 ac820518 ac83051c 
	3c020a0a 34427200 2403007a ac820520 ac830524 3c021931 34427d00 24037d0d 
	ac820528 ac83052c 3c02292f 34422800 24032629 ac820530 ac830534 3c022929 
	34422600 24032629 ac820538 ac83053c 3c024d40 34422000 24033048 ac820540 
	ac830544 3c020808 34420800 24033808 ac820548 ac83054c 3c020808 34423800 
	24030808 ac820550 ac830554 3c02c8ac 3442ba00 24032f10 ac820558 ac83055c 
	3c022834 3442fa00 24032f10 ac820560 ac830564 3c027b00 00001821 ac820568 
	ac83056c 3c022a14 34422200 24030814 ac820570 ac830574 3c022a14 34420800 
	24032214 ac820578 ac83057c 3c025500 3442aa00 3403aa00 ac820580 ac830584 
	3c02aa55 3442aa00 3403aa55 ac820588 ac83058c 3c0200ff 00001821 ac820590 
	ac830594 3c0210ff 24031010 ac820598 ac83059c 3c0214ff 24031414 ac8205a0 
	ac8305a4 3c02ff00 3442ff00 24031010 ac8205a8 ac8305ac 3c02f010 3442f000 
	24031010 ac8205b0 ac8305b4 3c0614fc 24071414 ac8605b8 ac8705bc 3c06f700 
	34c6ff00 24071414 ac8605c0 ac8705c4 3c0aff00 354aff00 00005821 ac8a05c8 
	ac8b05cc 3c06f404 34c6fc00 24071414 ac8605d0 ac8705d4 3c061710 34c61f00 
	24071414 ac8605d8 ac8705dc 3c061f10 34c61f00 24071010 ac8605e0 ac8705e4 
	3c0c141f 240d1414 ac8c05e8 ac8d05ec 3c0c10f0 240d1010 ac8c05f0 ac8d05f4 
	3c0c001f 358c1000 00006821 ac8c05f8 ac8d05fc 3c0c101f 358c1000 240d1010 
	ac8c0600 ac8d0604 3c0c10f0 358c1000 240d1010 ac8c0608 ac8d060c 3c0c00ff 
	358c1000 00006821 ac8c0610 ac8d0614 3c0c1010 358c1000 240d1010 ac8c0618 
	ac8d061c 3c0c10ff 358c1000 240d1010 ac8c0620 ac8d0624 3c0c00ff 358c1400 
	00006821 ac8c0628 ac8d062c ac8a0630 ac8b0634 3c0a1f10 354a1700 00005821 
	ac8a0638 ac8b063c 3c0afc04 354af400 00005821 ac8a0640 ac8b0644 3c0a1710 
	354a1700 240b1414 ac8a0648 ac8b064c 3c0af404 354af400 240b1414 ac8a0650 
	ac8b0654 3c0aff00 354af700 00005821 ac8a0658 ac8b065c ac880660 ac890664 
	3c08f700 3508f700 24091414 ac880668 ac89066c 3c081417 35081400 24091414 
	ac880670 ac890674 ac860678 ac87067c 3c0614f4 34c61400 24071414 ac860680 
	ac870684 ac820688 ac83068c 3c021f10 34421f00 00001821 ac820690 ac830694 
	3c02001f 34421400 00001821 ac820698 ac83069c 3c0200fc 34421400 00001821 
	ac8206a0 ac8306a4 3c02f010 3442f000 00001821 ac8206a8 ac8306ac 3c02ff10 
	3442ff00 24031010 ac8206b0 ac8306b4 3c0214ff 34421400 24031414 ac8206b8 
	ac8306bc 3c02101f 24031010 ac8206c0 ac8306c4 3c0200f0 34421000 00001821 
	ac8206c8 ac8306cc 2402ff00 3403ffff ac8206d0 ac8306d4 3c02f0f0 3442f000 
	3403f0f0 ac8206d8 ac8306dc 3c02ff00 3403ffff ac8206e0 ac8306e4 3c0200ff 
	3442ff00 00001821 ac8206e8 ac8306ec 3c020f0f 34420f00 24030f0f ac8206f0 
	ac8306f4 3c024438 34424400 24033844 ac8206f8 ac8306fc 3c024a4a 34423400 
	3403fc4a ac820700 ac830704 3c020206 34420600 24037e02 ac820708 ac83070c 
	3c02027e 34420200 2403027e ac820710 ac830714 3c024941 34426300 24036355 
	ac820718 ac83071c 3c02443c 34420400 24033844 ac820720 ac830724 3c02201e 
	34422000 2403407e ac820728 ac83072c 3c027e02 34420200 24030602 ac820730 
	ac830734 3c02e7a5 34429900 340399a5 ac820738 ac83073c 3c02492a 34421c00 
	24031c2a ac820740 ac830744 3c020172 34424c00 24034c72 ac820748 ac83074c 
	3c024d4d 34423000 2403304a ac820750 ac830754 3c027848 34423000 24033048 
	ac820758 ac83075c 3c025a46 34423d00 3403bc62 ac820760 ac830764 3c024949 
	24033e49 ac820768 ac83076c 3c020101 34427e00 24037e01 ac820770 ac830774 
	3c022a2a 34422a00 24032a2a ac820778 ac83077c 3c025f44 34424400 24034444 
	ac820780 ac830784 3c024a44 34424000 24034051 ac820788 ac83078c 3c024a51 
	34424000 24034044 ac820790 ac830794 3c02ff01 34420300 00001821 ac820798 
	ac83079c 3c02ff00 3403e080 ac8207a0 ac8307a4 3c026b6b 34420800 24030808 
	ac8207a8 ac8307ac 3c023624 34423600 24033612 ac8207b0 ac8307b4 3c02090f 
	34420600 2403060f ac8207b8 ac8307bc 3c021818 00001821 ac8207c0 ac8307c4 
	3c021010 00001821 ac8207c8 ac8307cc 3c02ff01 34420100 24033040 ac8207d0 
	ac8307d4 3c020101 34421e00 2403001f ac8207d8 ac8307dc 3c021d17 34421200 
	24030019 ac8207e0 ac8307e4 3c023c3c 34423c00 2403003c ac8207e8 ac8307ec 
	00001021 00001821 ac8207f0 ac8307f4 03e00008 00000000 
End CFunction



